import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Background extends World
{
    private int enemySpawnRate = 6;
    private int enemySpeed = 1;
    public int  score=0;
    public int  health=5, life=3, maxHealth=5;
    private int hit=0;
    private int level2 = 150; 
    GreenfootSound bgSound = new GreenfootSound("sounds.mp3");
    public Background()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        setPaintOrder(ksatria.class,Musuh2.class,peluru1.class);
        bgSound.playLoop();
        bgSound.setVolume(70);
        prepare();
    }

    public void prepare()
    {
        ksatria ksatria = new ksatria();
        addObject(ksatria, 535, 300);
        titik titik = new titik();
        addObject(titik, 558, 305);

        daun daun = new daun();
        addObject(daun, 25, 174);
        daun daun2 = new daun();
        addObject(daun2, 63, 176);
        daun.setLocation(21, 173);
        daun2.setLocation(54, 169);
        daun daun3 = new daun();
        addObject(daun3, 93, 171);
        daun3.setLocation(88, 166);
        daun daun4 = new daun();
        addObject(daun4, 127, 170);
        daun4.setLocation(121, 162);
        daun daun5 = new daun();
        addObject(daun5, 162, 165);
        daun5.setLocation(157, 160);
        daun daun6 = new daun();
        addObject(daun6, 198, 165);
        daun6.setLocation(192, 159);
        daun daun7 = new daun();
        addObject(daun7, 234, 163);
        daun7.setLocation(226, 157);
        daun daun8 = new daun();
        addObject(daun8, 270, 160);
        daun8.setLocation(259, 156);
        daun daun9 = new daun();
        addObject(daun9, 297, 161);
        daun9.setLocation(293, 154);
        daun8.setLocation(258, 157);
        daun9.setLocation(290, 154);
        daun8.setLocation(257, 156);
        daun8.setLocation(258, 155);
        daun9.setLocation(288, 153);
        daun9.setLocation(292, 153);
        daun daun10 = new daun();
        addObject(daun10, 332, 158);
        daun10.setLocation(325, 149);
        daun daun11 = new daun();
        addObject(daun11, 366, 152);
        daun11.setLocation(358, 145);
        daun daun12 = new daun();
        addObject(daun12, 412, 149);
        daun12.setLocation(391, 141);
        daun daun13 = new daun();
        addObject(daun13, 431, 141);
        daun13.setLocation(425, 139);
        daun daun14 = new daun();
        addObject(daun14, 465, 144);
        daun14.setLocation(457, 138);
        daun14.setLocation(460, 136);
        daun daun15 = new daun();
        addObject(daun15, 502, 141);
        daun15.setLocation(492, 134);
        daun daun16 = new daun();
        addObject(daun16, 534, 137);
        daun16.setLocation(526, 132);
        daun daun17 = new daun();
        addObject(daun17, 569, 136);
        daun17.setLocation(559, 130);
        daun daun18 = new daun();
        addObject(daun18, 598, 134);
        daun18.setLocation(589, 128);
    }
    
     public void act()
     {
      randommusuh1();
      randommusuh2();   
      showNyawa();
      showScore();
      showHit();
    }
       
    public void randommusuh1()
    {
      if(Greenfoot.getRandomNumber(1000) < enemySpawnRate)
        {
            Musuh1 Musuhe = new Musuh1();
            Musuhe.setSpeed(enemySpeed);
            addObject(Musuhe, Greenfoot.getRandomNumber(getWidth()-20)+10, -30);
           
        }
    }
    
    public void randommusuh2()
    {
        int x = -5;
        int y = Greenfoot.getRandomNumber(245);
        if(Greenfoot.getRandomNumber(400)<3){
         addObject(new Musuh2(), x, y+140);
        }
   }

    public void addScore(int counter)
    {
        score = score + counter;
        if(level2 == score){
            Next next = new Next();
            addObject(next, 300, 160);
            showText("Score Terbaru : " + score, 300, 198);
        }
    }
    
    public void addNyawa(int x)
    {
        health = health + x;
        
        if(health==0 && life>0){
            life--;
            health=maxHealth;
        }
        
        if (life == 0)
        {
            GameOver gameover = new GameOver();
            addObject(gameover, 298, 152);
            gameover.setLocation(296, 122);
            showText("You Final Score  " + score + "Attack !", 300, 180); 
            Greenfoot.playSound("end.wav");
            PlayAgain playagain = new PlayAgain();
            addObject(playagain, 318, 335);
            playagain.setLocation(296, 250);
            
            health=0;
            Greenfoot.stop();
        }
        showNyawa();
    }
    
    private void showNyawa()
    {
        showText("Health: " + health, 100, 25);
        showText("Life: " + life, 185, 25); 
    }

    public void showScore()
    {
     showText("Score: " + score, 275, 25);
    }
    
    public void addhit(int ulang){
        hit = hit + ulang;
    }
    
     private void showHit()
    {
     showText("Hit: " + hit, 480, 25);
    }
    
    
    public void started()
    {
        bgSound.playLoop();
    }

    public void stopped()
    {
        bgSound.pause();
    }
    
    
}

